//========================================================================
// Bunch of #defines for DiFi
// Set various options
//========================================================================

#ifndef _DIFI_DEFINES_H_
#define _DIFI_DEFINES_H_

#include <vec3f.hpp>
#include <vec2f.hpp>
#include <stdlib.h>
#include <math.h>

#pragma warning( disable : 4786 )

// Math stuff
#ifndef M_PI
#define M_PI 3.14159265358979323846f
#endif

#ifndef M_PI_2
#define M_PI_2 1.57079632679489661923f
#endif

#ifndef M_PI_4
#define M_PI_4 0.78539816339744830962f
#endif

#ifndef M_2_PI
#define M_2_PI 6.28318530717958647692f
#endif

#ifndef MAXFLOAT
#define MAXFLOAT 3.40282347e+38f
#endif

// Comparators
#ifndef MAX
#define MAX(a,b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b) (((a) < (b)) ? (a) : (b))
#endif

// DISTANCE CONSTANTS
#define INFINITY 3.0e+38f
#define EPSILON 1e-6f
#define SQRT2 1.4142135623730950488016887

// uncomment for dynamic sites
//#define STATIC_SITES 1


// Number of bits to use in FindMax query
#define MAX_DEPTH_RES 12

// Convenience
#define ffor(a, b) for (int a = 0; a < b; a++)

// NORMALIZED RAND FUNCTION [0,1]
#define RAND() (float)(rand()/(float)RAND_MAX)  

// MAX NUM SITES
#define SITE_BITS 16
#define MAX_SITES (1 << SITE_BITS)
#define MAX_ID    (1 << 24)
#define SITE_MASK 0xffff
#define OBJ_MASK  0xffff

static unsigned char OBJ_COLOR[] = { 250,250, 250};
static unsigned char OBJ_PNS_COLOR[]  = {  80, 80, 230};
static unsigned char TRI_PNS1_COLOR[] = { 240, 60, 40};
static unsigned char TRI_UNDERSAMPLE_COLOR[] = { 0, 0, 240};
static unsigned char TRI_NOVD_COLOR[] = { 0, 240, 0};

// type defs
typedef float real;
typedef Vec3<real> Vec3r;
typedef Vec3<int> Vec3i;
typedef Vec2<real> Vec2r;
typedef unsigned char byte;

#endif