#include "pt_site.hpp"
#include <vec2f.hpp>

#include <assert.h>
#include <math.h>
#include <cg/cgGL.h>

extern CGparameter cgPtCoordParam;


// Cg program for point sites should be bound!
void PointSite::ComputeDist(real d) const
{

  cgGLSetParameter2fv(cgPtCoordParam, _pt);

  real dx = d;

  real x0 = _pt.x - dx;
  real x1 = _pt.x + dx;

  real y0 = _pt.y - dx;
  real y1 = _pt.y + dx;

  glBegin(GL_QUADS);

  glVertex2f(x0,y0);
  glVertex2f(x1,y0);
  glVertex2f(x1,y1);
  glVertex2f(x0,y1);

  glEnd();

  // For GL_TRIANGLES
  // Tri 1

 // glMultiTexCoord3fARB(GL_TEXTURE1_ARB,-dx,-dx,dz);
	//glVertex2f(x0,y0);

	//glMultiTexCoord3fARB(GL_TEXTURE1_ARB,dx,-dx,dz);
	//glVertex2f(x1,y0);

	//glMultiTexCoord3fARB(GL_TEXTURE1_ARB,dx,dx,dz);
	//glVertex2f(x1,y1);

 // // Tri 2
	//glMultiTexCoord3fARB(GL_TEXTURE1_ARB,-dx,-dx,dz);
	//glVertex2f(x0,y0);

	//glMultiTexCoord3fARB(GL_TEXTURE1_ARB,dx,dx,dz);
	//glVertex2f(x1,y1);

 // glMultiTexCoord3fARB(GL_TEXTURE1_ARB,-dx,dx,dz);
	//glVertex2f(x0,y1);
}

void PointSite::Draw()
{
  glBegin(GL_POINTS);
  glVertex3fv(_pt);
  glEnd();
}