//========================================================================
// Point Site Classes for DiFi
//========================================================================

#ifndef _DIFI_PT_SITE_H_
#define _DIFI_PT_SITE_H_

#include "vec3f.hpp"
#include <GL/glew.h>
#include <GL/glut.h>

#include "site.hpp"


  class PointSite : public Site
  {
  protected:
    // METHODS
    void Init()
    {
      Site::Init();
      _type   = PT_SITE;
    }
  public:
    // Data
    Vec2r _pt;
    // Constructors
    PointSite() { Init(); }
    PointSite(const Vec2r& pt) : _pt(pt) { Init(); }

    // Distance function methods
    float DepthFunc(const Vec2r& p) const { return (_pt-p).Length(); }
    float DepthFunc2(const Vec2r& p)  const { return (_pt-p).LengthSqr(); }
    inline bool InRange(const Vec2r& dmin, const Vec2r& dmax)
    {
      return (  (_pt.x > dmin.x) && (_pt.x < dmax.x)
              &&(_pt.y > dmin.y) && (_pt.y < dmax.y) );
    }
        
    // Drawing methods
    void Draw();
    // Compute distance functions
    void ComputeDist(real max_dist) const;
  };

#endif
