//========================================================================
// Site classes for DiFi
//========================================================================


#ifndef _DIFI_SITE_H_
#define _DIFI_SITE_H_

#include <vec3f.hpp>
#include <vector>
using std::vector;
#include <iostream>
using namespace std;

#include "defines.h"
#include "color_ids.hpp"
#include "site_ids.h"

#include <GL/glew.h>
#include <windows.h>
#include <memory.h>

enum SiteType { PT_SITE, LINE_SITE, TRI_SITE };
// Abstract class
class Site;

//========================================================================
// Base class
//========================================================================
class Site
{
protected:
  // type membership
  SiteType   _type;

  // id, in RGBA
  unsigned int _id;
  float        _fid;

  // METHODS
  void Init()
  {
  }

public:
  // METHODS
  // Constructors
  Site()
  {
  }
  Site(unsigned int obj_id, unsigned int id)
  {
    SetID(obj_id, id);
  }
  // Set methods
  void SetID(unsigned int obj_id, unsigned int site_id) 
  { 
    _id  = vdID2Int(obj_id, site_id); 
    _fid = vdID2Float(obj_id, site_id);
  }
  // Get Methods
  unsigned int GetSiteID() const { return (_id & SITE_MASK); }
  unsigned int GetObjId() const { return (_id >> SITE_BITS); }
  // A single color packed into a float channel
  float GetColorIDF() const
  {
    return _fid;
  }

};



#endif