//========================================================================
// Routines for converting (object id, site id) <-> float id
//========================================================================

#ifndef _SITE_IDS_H_
#define _SITE_IDS_H_

#include "defines.h"

inline unsigned int vdID2Int(unsigned int obj_id, unsigned int site_id)
{
  unsigned int id = (site_id & SITE_MASK)+((obj_id & OBJ_MASK) << SITE_BITS);
  return id;  
}

inline void vdInt2ID(unsigned int id, unsigned int& obj_id, unsigned int& site_id)
{
  site_id = id & SITE_MASK;
  obj_id  = (id >> SITE_BITS);
}

inline float vdID2Float(unsigned int obj_id, unsigned int site_id)
{
  return (float)(vdID2Int(obj_id, site_id))/MAX_ID;  
}

inline void vdFloat2ID(float fid, unsigned int& obj_id, unsigned int& site_id)
{
  unsigned int id = (unsigned int)(fid * MAX_ID);
  vdInt2ID(id, obj_id, site_id);
}

inline void vdFloat2Int(float fid, unsigned int& id)
{
  id = (unsigned int)(fid * MAX_ID);
}


#endif